//              dasm.cpp
//
//
//
//         Borg Disassembler v2.00
//	  	     by Cronos
//
//         complete rewrite from v1
//
//         pre-beta build 16 - how time flies!
//
//
//
// Contributors:
//  - Mark Ogden - bugfixes, and mods for assembly under VC++
//               - changes from wvsprintf to wsprintf to allow compilation under VC++

#include <windows.h>
#include <commctrl.h>

#include "menuids.rh"
#include "fileload.h"
#include "data.h"
#include "schedule.h"
#include "proctab.h"
#include "disasm.h"
#include "dasm.h"
#include "names.h"
#include "mainwind.h"
#include "imports.h"
#include "exports.h"
#include "xref.h"
#include "relocs.h"
#include "srch.h"

CRITICAL_SECTION cs;
volatile BOOL KillThread;
volatile BOOL InThread;
globaloptions options;

fileloader floader;
dataseg dta;
schedule scheduler;
disasm dsm;
names name;
xref xrefs;
imports import;
exports export;
relocs reloc;

LRESULT CALLBACK dasm(HWND,UINT,WPARAM,LPARAM);
BOOL FAR PASCAL habox(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam);
BOOL FAR PASCAL shutbox(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam);
BOOL FAR PASCAL helpshortcuts(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam);
BOOL TestThread(void);
void optionsinit(void);
BOOL newfile(HWND hwnd);
void Thread(PVOID pvoid);
BOOL savefile(HWND hwnd,BOOL printaddrs);
void StatusMessage(char *msg);
void savedb(void);
void loaddb(void);
void changemenus(void);

OPENFILENAME ofn;
char szDirName[MAX_PATH];
char szFile[260];
char szFilesave[260];
char szFilter[260];
char szFileTitle[260];
char winname[300];
HANDLE hInst,hwndStatusBar;
HANDLE ThreadHandle;
HWND mainwindow;
DWORD ThreadId;
RECT mainwnd,mainwndsize,StatusWindowSize;
int cxChar,cyChar;
HMENU rmenu;

char szWinName[]="Dasm";
char fname[]="Borg Disassembler";

#pragma warn -par
int WINAPI WinMain(HINSTANCE hThisInst,HINSTANCE hPrevInst,LPSTR lpszArgs,int nWinMode)
{ HWND hwnd;
  MSG msg;
  WNDCLASSEX wcl;
  int cx,cy;

  InitCommonControls();

  cx=GetSystemMetrics(SM_CXFULLSCREEN);
  cy=GetSystemMetrics(SM_CYFULLSCREEN);
  /* Define window class */
  wcl.hInstance=hThisInst;
  wcl.lpszClassName=szWinName;
  wcl.lpfnWndProc=dasm;
  wcl.style=CS_DBLCLKS|CS_HREDRAW|CS_VREDRAW;

  wcl.cbSize=sizeof(WNDCLASSEX);

  wcl.hIcon=LoadIcon(NULL,IDI_APPLICATION);
  wcl.hIconSm=LoadIcon(NULL,IDI_WINLOGO);

  wcl.hCursor=LoadCursor(NULL,IDC_ARROW);
  wcl.lpszMenuName=MAKEINTRESOURCE(main_menu);

  wcl.cbClsExtra=0;
  wcl.cbWndExtra=0;

  wcl.hbrBackground=(HBRUSH)(COLOR_APPWORKSPACE+1);

  hInst=hThisInst;

  /* Register window class */
  if(!RegisterClassEx(&wcl))return 0;

  /* Create window */
  strcpy(winname,"Borg Disassembler v2.00 beta-build 16");
  hwnd=CreateWindow(szWinName,winname,WS_OVERLAPPEDWINDOW,
			 cx/2-320,cy/2-230,640,480,
			 NULL,NULL,hThisInst,NULL);

  mainwndsize.top=0;
  mainwndsize.bottom=cy-1;
  mainwndsize.left=0;
  mainwndsize.right=cx-1;

  /* Display window */
  ShowWindow(hwnd,nWinMode);
  UpdateWindow(hwnd);

  /* Message Loop */
  while(GetMessage(&msg,NULL,0,0))
  { TranslateMessage(&msg);
	 DispatchMessage(&msg);
  }

  return msg.wParam;
}
#pragma warn +par

LRESULT CALLBACK dasm(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam)
{ HDC hdc;
  TEXTMETRIC tm;
  POINT point;
  lptr scrll;
  int killcount;
  mainwindow=hwnd;
  switch(message)
  { case WM_COMMAND:
		switch(LOWORD(wParam))
		{ case file_exit:
			 SendMessage(mainwindow,WM_CLOSE,0,0);
			 break;
		  case file_save:
			 savefile(hwnd,TRUE);
			 break;
		  case save_database:
			 savedb();
			 break;
		  case load_database:
			 loaddb();
			 break;
		  case save_asm:
			 savefile(hwnd,FALSE);
			 break;
		  case file_open:
			 newfile(hwnd);
			 break;
		  case view_segment:
			 dta.segviewer();
			 break;
		  case view_names:
			 name.namesviewer();
			 break;
		  case view_imports:
			 import.importsviewer();
			 break;
		  case view_exports:
			 export.exportsviewer();
			 break;
		  case view_xrefs:
			 xrefs.xrefsviewer();
			 break;
		  case make_code:
			 scheduler.addtask(user_makecode,priority_userrequest,nlptr,NULL);
			 break;
		  case make_dword:
			 scheduler.addtask(user_makedword,priority_userrequest,nlptr,NULL);
			 break;
		  case make_word:
			 scheduler.addtask(user_makeword,priority_userrequest,nlptr,NULL);
			 break;
		  case make_string:
			 scheduler.addtask(user_makestring,priority_userrequest,nlptr,NULL);
			 break;
		  case pascal_string:
			 scheduler.addtask(user_pascalstring,priority_userrequest,nlptr,NULL);
			 break;
		  case uc_string:
			 scheduler.addtask(user_ucstring,priority_userrequest,nlptr,NULL);
			 break;
		  case up_string:
			 scheduler.addtask(user_upstring,priority_userrequest,nlptr,NULL);
			 break;
		  case dos_string:
			 scheduler.addtask(user_dosstring,priority_userrequest,nlptr,NULL);
			 break;
		  case general_string:
			 scheduler.addtask(user_generalstring,priority_userrequest,nlptr,NULL);
			 break;
		  case argover_dec:
			 scheduler.addtask(user_argoverdec,priority_userrequest,nlptr,NULL);
			 break;
		  case argover_hex:
			 scheduler.addtask(user_argoverhex,priority_userrequest,nlptr,NULL);
			 break;
		  case offset_dseg:
			 scheduler.addtask(user_argoveroffsetdseg,priority_userrequest,nlptr,NULL);
			 break;
		  case argover_char:
			 scheduler.addtask(user_argoverchar,priority_userrequest,nlptr,NULL);
			 break;
		  case undefine_line:
			 scheduler.addtask(user_undefineline,priority_userrequest,nlptr,NULL);
			 break;
		  case undefine_lines:
			 scheduler.addtask(user_undefinelines,priority_userrequest,nlptr,NULL);
			 break;
		  case line_jumpto:
			 scheduler.addtask(user_jumpto,priority_userrequest,nlptr,NULL);
			 break;
		  case Name_Location:
			 name.nameloc();
			 break;
		  case help_short:
			 DialogBox(hInst,MAKEINTRESOURCE(help_shortcuts),hwnd,(DLGPROC)helpshortcuts);
			 break;
		  case help_about:
			 DialogBox(hInst,MAKEINTRESOURCE(D_help_about),hwnd,(DLGPROC)habox);
			 break;
		  case Jump_Back:
			 scheduler.addtask(user_jumpback,priority_userrequest,nlptr,NULL);
			 break;
		  case main_search:
			 searchengine();
			 break;
		  default:
			 return DefWindowProc(hwnd,message,wParam,lParam);
		}
		break;
	 case WM_CHAR:
		switch(wParam)
		{ case 'c':
			 scheduler.addtask(user_makecode,priority_userrequest,nlptr,NULL);
			 break;
		  case 'C':
			 scheduler.addtask(user_argoverchar,priority_userrequest,nlptr,NULL);
			 break;
		  case 'd':
			 scheduler.addtask(user_makedword,priority_userrequest,nlptr,NULL);
			 break;
		  case 'D':
			 scheduler.addtask(user_argoverdec,priority_userrequest,nlptr,NULL);
			 break;
		  case 'H':
			 scheduler.addtask(user_argoverhex,priority_userrequest,nlptr,NULL);
			 break;
		  case 'n':
			 name.nameloc();
			 break;
		  case 'o':
			 scheduler.addtask(user_argoveroffsetdseg,priority_userrequest,nlptr,NULL);
			 break;
		  case 'p':
			 scheduler.addtask(user_pascalstring,priority_userrequest,nlptr,NULL);
			 break;
		  case 's':
			 scheduler.addtask(user_makestring,priority_userrequest,nlptr,NULL);
			 break;
		  case 'u':
			 scheduler.addtask(user_undefineline,priority_userrequest,nlptr,NULL);
			 break;
		  case 'U':
			 scheduler.addtask(user_undefinelines,priority_userrequest,nlptr,NULL);
			 break;
		  case 'w':
			 scheduler.addtask(user_makeword,priority_userrequest,nlptr,NULL);
			 break;
		  default:
			 break;
		}
		break;
	 case WM_LBUTTONDOWN:
		dsm.setpos(HIWORD(lParam));
		break;
	 case WM_RBUTTONDOWN:
		dsm.setpos(HIWORD(lParam));
		point.x=LOWORD(lParam);
		point.y=HIWORD(lParam);
		ClientToScreen(mainwindow,&point);
		TrackPopupMenu(rmenu,0,point.x,point.y,0,mainwindow,NULL);
		break;
	 case WM_PAINT:
		if(!KillThread)DoPaint(hwnd,cxChar,cyChar);
		else ValidateRect(mainwindow,NULL);
		break;
	 case WM_CLOSE:
		if(MessageBox(mainwindow,"Are you sure that you want to exit Borg ?\n\rHit Yes To Exit\n\rHit No to Stay","Borg Disassembler",
		  MB_ICONEXCLAMATION|MB_YESNO)==IDNO)break;
		KillThread=TRUE;
		scheduler.addtask(quitborg,priority_quit,nlptr,NULL);
		if(InThread)SetThreadPriority(ThreadHandle,THREAD_PRIORITY_TIME_CRITICAL);
		DestroyWindow(mainwindow);
		return 0;
	 case WM_DESTROY:
		KillThread=TRUE;
		killcount=0;
		Sleep(0);
		SetPriorityClass(ThreadHandle,HIGH_PRIORITY_CLASS);
		if(InThread)
		  while(TestThread())
		  { killcount++;
			 if(killcount>2)
			 { // this is a nasty way of getting out.
				// sometimes the thread just will not exit nicely when its busy.
				if(TerminateThread(ThreadHandle,1))
				{ CloseHandle(ThreadHandle);
				  break;
				}
			 }
		  }
		DeleteCriticalSection(&cs);
		PostQuitMessage(0);
		break;
	 case WM_SIZE:
		mainwndsize.top=0;
		mainwndsize.left=0;
		mainwndsize.right=LOWORD(lParam);
		mainwndsize.bottom=HIWORD(lParam);
		GetWindowRect(hwndStatusBar,&StatusWindowSize);
		GetWindowRect(mainwindow,&mainwnd);
		MoveWindow(hwndStatusBar,0,mainwndsize.bottom-StatusWindowSize.bottom+StatusWindowSize.top,
		  mainwndsize.right,StatusWindowSize.bottom-StatusWindowSize.top,TRUE);
		break;
	 case WM_VSCROLL:
		switch(LOWORD(wParam))
		{ case SB_TOP:
			 break;
		  case SB_BOTTOM:
			 break;
		  case SB_LINEUP:
			 scrll.assign(0,-1);
			 if(InThread)scheduler.addtask(scrolling,priority_userrequest,scrll,NULL);
			 break;
		  case SB_LINEDOWN:
			 scrll.assign(0,1);
			 if(InThread)scheduler.addtask(scrolling,priority_userrequest,scrll,NULL);
			 break;
		  case SB_PAGEUP:
			 scrll.assign(0,-mainwndsize.bottom/cyChar+1);
			 if(InThread)scheduler.addtask(scrolling,priority_userrequest,scrll,NULL);
			 break;
		  case SB_PAGEDOWN:
			 scrll.assign(0,mainwndsize.bottom/cyChar-1);
			 if(InThread)scheduler.addtask(scrolling,priority_userrequest,scrll,NULL);
			 break;
		  case SB_THUMBTRACK:
			 break;
		  default:
			 break;
		}
		break;
	 case WM_HSCROLL:
		switch(LOWORD(wParam))
		{ case SB_LINEUP:
			 scrll.assign(0,-1);
			 scheduler.addtask(hscroll,priority_userrequest,scrll,NULL);
			 break;
		  case SB_LINEDOWN:
			 scrll.assign(0,1);
			 scheduler.addtask(hscroll,priority_userrequest,scrll,NULL);
			 break;
		  case SB_PAGEUP:
			 scrll.assign(0,-8);
			 scheduler.addtask(hscroll,priority_userrequest,scrll,NULL);
			 break;
		  case SB_PAGEDOWN:
			 scrll.assign(0,8);
			 scheduler.addtask(hscroll,priority_userrequest,scrll,NULL);
			 break;
		  case SB_THUMBTRACK:
			 break;
		  default:
			 break;
		}
		break;
	 case WM_CREATE:
		optionsinit();
		hdc=GetDC(hwnd);
		SelectObject(hdc,GetStockObject(SYSTEM_FIXED_FONT));
		GetTextMetrics(hdc,&tm);
		cxChar=tm.tmAveCharWidth;
		cyChar=tm.tmHeight+tm.tmExternalLeading;
		ReleaseDC(hwnd,hdc);
		InitializeCriticalSection(&cs);
		hwndStatusBar=CreateStatusWindow(WS_CHILD|WS_VISIBLE|WS_CLIPSIBLINGS|CCS_BOTTOM,
		  "No File Loaded",hwnd,2);
		GetWindowRect(hwndStatusBar,&StatusWindowSize);
		GetWindowRect(mainwindow,&mainwnd);
		SetScrollRange(hwnd,SB_VERT,0,2,FALSE);
		SetScrollPos(hwnd,SB_VERT,1,FALSE);
		KillThread=FALSE;
		InThread=FALSE;
		InitPaintSubsystem(cyChar);
		rmenu=LoadMenu(hInst,MAKEINTRESOURCE(right_click_menu));
		rmenu=GetSubMenu(rmenu,0);
		break;
	 case WM_KEYDOWN:
		switch(wParam)
		{ case VK_HOME:
			 SendMessage(hwnd,WM_VSCROLL,SB_TOP,0L);
			 break;
		  case VK_PRIOR:
			 SendMessage(hwnd,WM_VSCROLL,SB_PAGEUP,0L);
			 break;
		  case VK_NEXT:
			 SendMessage(hwnd,WM_VSCROLL,SB_PAGEDOWN,0L);
			 break;
		  case VK_DOWN:
			 SendMessage(hwnd,WM_VSCROLL,SB_LINEDOWN,0L);
			 break;
		  case VK_UP:
			 SendMessage(hwnd,WM_VSCROLL,SB_LINEUP,0L);
			 break;
		  case VK_LEFT:
			 SendMessage(hwnd,WM_HSCROLL,SB_PAGEUP,0L);
			 break;
		  case VK_RIGHT:
			 SendMessage(hwnd,WM_HSCROLL,SB_PAGEDOWN,0L);
			 break;
		  case VK_RETURN:
			 scheduler.addtask(user_jumpto,priority_userrequest,nlptr,NULL);
			 break;
		  case VK_ESCAPE:
			 scheduler.addtask(user_jumpback,priority_userrequest,nlptr,NULL);
			 break;
		  case VK_F1:
			 DialogBox(hInst,MAKEINTRESOURCE(help_shortcuts),hwnd,(DLGPROC)helpshortcuts);
			 break;
		}
		break;
	 default:
		return DefWindowProc(hwnd,message,wParam,lParam);
  }
  return 0;
}

#pragma warn -par
BOOL FAR PASCAL habox(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam)
{ static HBRUSH hbrush;
  RECT drect;
  switch(message)
  { case WM_COMMAND:
		switch(wParam)
		{ case IDC_BUTTON1:
			 EndDialog(hdwnd,NULL);
			 return TRUE;
		}
		break;
	 case WM_INITDIALOG:
		hbrush=CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
		GetWindowRect(hdwnd,&drect);
		MoveWindow(hdwnd,((mainwnd.right+mainwnd.left)-(drect.right-drect.left))/2,
		  ((mainwnd.bottom+mainwnd.top)-(drect.bottom-drect.top))/2,drect.right-drect.left,drect.bottom-drect.top,TRUE);
		SetFocus(GetDlgItem(hdwnd,IDC_BUTTON1));
		return 0;
	 case WM_DESTROY:
		DeleteObject(hbrush);
		return 0;
	 case WM_CTLCOLORSTATIC:
	 case WM_CTLCOLORDLG:
	 case WM_SYSCOLORCHANGE:
		SetBkColor((HDC)wParam,GetSysColor(COLOR_BTNFACE));
		return (LRESULT)hbrush;
  }
  return FALSE;
}
#pragma warn -par

void changemenus(void)
{ HMENU hMenu;
  hMenu=GetMenu(mainwindow);
  EnableMenuItem(hMenu,file_open,MF_GRAYED);
  EnableMenuItem(hMenu,file_save,MF_ENABLED);
  EnableMenuItem(hMenu,save_asm,MF_ENABLED);
  EnableMenuItem(hMenu,view_segment,MF_ENABLED);
  EnableMenuItem(hMenu,view_names,MF_ENABLED);
  EnableMenuItem(hMenu,view_xrefs,MF_ENABLED);
  EnableMenuItem(hMenu,view_imports,MF_ENABLED);
  EnableMenuItem(hMenu,view_exports,MF_ENABLED);
  EnableMenuItem(hMenu,make_code,MF_ENABLED);
  EnableMenuItem(hMenu,undefine_line,MF_ENABLED);
  EnableMenuItem(hMenu,undefine_lines,MF_ENABLED);
  EnableMenuItem(hMenu,line_jumpto,MF_ENABLED);
  EnableMenuItem(hMenu,make_dword,MF_ENABLED);
  EnableMenuItem(hMenu,make_word,MF_ENABLED);
  EnableMenuItem(hMenu,make_string,MF_ENABLED);
  EnableMenuItem(hMenu,pascal_string,MF_ENABLED);
  EnableMenuItem(hMenu,uc_string,MF_ENABLED);
  EnableMenuItem(hMenu,up_string,MF_ENABLED);
  EnableMenuItem(hMenu,dos_string,MF_ENABLED);
  EnableMenuItem(hMenu,general_string,MF_ENABLED);
  EnableMenuItem(hMenu,Name_Location,MF_ENABLED);
  EnableMenuItem(hMenu,Jump_Back,MF_ENABLED);
  EnableMenuItem(hMenu,argover_dec,MF_ENABLED);
  EnableMenuItem(hMenu,argover_hex,MF_ENABLED);
  EnableMenuItem(hMenu,argover_char,MF_ENABLED);
  EnableMenuItem(hMenu,offset_dseg,MF_ENABLED);
  EnableMenuItem(hMenu,main_search,MF_ENABLED);
  EnableMenuItem(hMenu,save_database,MF_ENABLED);
  EnableMenuItem(hMenu,load_database,MF_GRAYED);
  EnableMenuItem(rmenu,make_code,MF_ENABLED);
  EnableMenuItem(rmenu,undefine_line,MF_ENABLED);
  EnableMenuItem(rmenu,undefine_lines,MF_ENABLED);
  EnableMenuItem(rmenu,line_jumpto,MF_ENABLED);
  EnableMenuItem(rmenu,make_dword,MF_ENABLED);
  EnableMenuItem(rmenu,make_word,MF_ENABLED);
  EnableMenuItem(rmenu,make_string,MF_ENABLED);
  EnableMenuItem(rmenu,pascal_string,MF_ENABLED);
  EnableMenuItem(rmenu,uc_string,MF_ENABLED);
  EnableMenuItem(rmenu,up_string,MF_ENABLED);
  EnableMenuItem(rmenu,dos_string,MF_ENABLED);
  EnableMenuItem(rmenu,general_string,MF_ENABLED);
  EnableMenuItem(rmenu,Name_Location,MF_ENABLED);
  EnableMenuItem(rmenu,view_xrefs,MF_ENABLED);
  EnableMenuItem(rmenu,argover_dec,MF_ENABLED);
  EnableMenuItem(rmenu,argover_hex,MF_ENABLED);
  EnableMenuItem(rmenu,argover_char,MF_ENABLED);
  EnableMenuItem(rmenu,offset_dseg,MF_ENABLED);
}

BOOL newfile(HWND hwnd)
{ int cbString,i;
  char chReplace;
  GetCurrentDirectory(sizeof(szDirName),szDirName);
  szFile[0]=0;
  cbString=LoadString(hInst,IDS_FILTERSTRING,szFilter,sizeof(szFilter));
  chReplace=szFilter[cbString-1];
  for(i=0;szFilter[i]!=0;i++)
  { if(szFilter[i]==chReplace) szFilter[i]=0;
  }
  ofn.lStructSize=sizeof(OPENFILENAME);
  ofn.hwndOwner=hwnd;
  ofn.lpstrFilter=szFilter;
  ofn.nFilterIndex=1;
  ofn.lpstrFile=szFile;
  ofn.nMaxFile=sizeof(szFile);
  ofn.lpstrFileTitle=szFileTitle;
  ofn.nMaxFileTitle=sizeof(szFileTitle);
  ofn.lpstrInitialDir=szDirName;
  ofn.lpstrCustomFilter=NULL;
  ofn.hInstance=NULL;
  ofn.lpTemplateName=NULL;
  ofn.lpstrTitle="Borg Disassembler - Select File";
  ofn.Flags=OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_LONGNAMES
				|OFN_EXPLORER;
  if(GetOpenFileName(&ofn))
  { if(floader.load(ofn.lpstrFile))
	 { StatusMessage("File Opened");
		strcat(winname," : ");
		strcat(winname,ofn.lpstrFile);
		SetWindowText(mainwindow,winname);
		InThread=TRUE;
		ThreadHandle=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)Thread,0,0,&ThreadId);
		changemenus();
	 }
	 else
		MessageBox(hwnd,"File open failed ?",fname,MB_OK|MB_ICONEXCLAMATION);
  }
  return 0;
}

#pragma warn -par
void Thread(PVOID pvoid)
{ // needs to setup initial schedule list
  // continually monitor schedule list for jobs
  do
  { if(scheduler.process())
		if(!KillThread)StatusMessage("Processing Completed");
	 Sleep(1);
  } while(!KillThread);
  InThread=FALSE;
  ExitThread(0);
}
#pragma warn +par

BOOL savefile(HWND hwnd,BOOL printaddrs)
{ int cbString,i;
  char chReplace;
  HWND sbox;
  if(scheduler.sizelist())
  { MessageBox(mainwindow,"There are still items to process yet","Borg Warning",MB_OK|MB_ICONEXCLAMATION);
	 return FALSE;
  }
  GetCurrentDirectory(sizeof(szDirName),szDirName);
  szFilesave[0]=0;
  cbString=LoadString(hInst,IDS_FILTERSAVE,szFilter,sizeof(szFilter));
  chReplace=szFilter[cbString-1];
  for(i=0;szFilter[i]!=0;i++)
  { if(szFilter[i]==chReplace) szFilter[i]=0;
  }
  ofn.lStructSize=sizeof(OPENFILENAME);
  ofn.hwndOwner=hwnd;
  ofn.lpstrFilter=szFilter;
  ofn.nFilterIndex=1;
  ofn.lpstrFile=szFilesave;
  ofn.nMaxFile=sizeof(szFilesave);
  ofn.lpstrFileTitle=szFileTitle;
  ofn.nMaxFileTitle=sizeof(szFileTitle);
  ofn.lpstrInitialDir=szDirName;
  ofn.lpstrCustomFilter=NULL;
  ofn.lpstrTitle="Borg Disassembler - Select File";
  ofn.Flags=OFN_PATHMUSTEXIST|OFN_HIDEREADONLY|OFN_LONGNAMES
				|OFN_EXPLORER;

  if(GetSaveFileName(&ofn))
  { sbox=CreateDialog(hInst,MAKEINTRESOURCE(save_box),mainwindow,(DLGPROC)savemessbox);
	 dsm.dumptofile(ofn.lpstrFile,printaddrs);
	 DestroyWindow(sbox);
  }
  return 0;
}

void StatusMessage(char *msg)
{ /*EnterCriticalSection(&cs);*/     // was causing locks (possibly)
  Status_SetText(hwndStatusBar,0,0,msg);
  /*LeaveCriticalSection(&cs);    */
}

void StatusMessageNItems(dword nolistitems)
{ static char buff[40];              // maybe this should be static ?
  buff[39]=0; // just in case
  wsprintf(buff,"Items to Process :%lu",nolistitems);
  StatusMessage(buff);
}

void optionsinit(void)
{ options.loaddebug=TRUE;
  options.mode16=FALSE;
  options.mode32=FALSE;
  options.loaddata=TRUE;
  options.loadresources=FALSE;
  options.cfa=TRUE;
  options.demangle=TRUE;
  options.processor=PROC_PENTIUM;
  options.codedetect=CD_PUSHBP;
}

BOOL TestThread(void)
{ HWND sbox;
  BOOL ttest;
  sbox=CreateDialog(hInst,MAKEINTRESOURCE(Borg_Shutdown),mainwindow,(DLGPROC)shutbox);
  if(InThread)SetThreadPriority(ThreadHandle,THREAD_PRIORITY_TIME_CRITICAL);
  Sleep(2000);
  DestroyWindow(sbox);
  Sleep(5000);
  EnterCriticalSection(&cs);
  ttest=InThread;
  LeaveCriticalSection(&cs);
  return ttest;
}

#pragma warn -par
BOOL FAR PASCAL shutbox(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam)
{ static HBRUSH hbrush;
  switch(message)
  { case WM_INITDIALOG:
		hbrush=CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
		return 0;
	 case WM_DESTROY:
		DeleteObject(hbrush);
		return 0;
	 case WM_CTLCOLORSTATIC:
	 case WM_CTLCOLORDLG:
	 case WM_SYSCOLORCHANGE:
		SetBkColor((HDC)wParam,GetSysColor(COLOR_BTNFACE));
		return (LRESULT)hbrush;
  }
  return FALSE;
}

BOOL FAR PASCAL helpshortcuts(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam)
{ static HBRUSH hbrush;
  RECT drect;
  switch(message)
  { case WM_COMMAND:
		{	switch(wParam)
		  { case IDOK:
				EndDialog(hdwnd,NULL);
				return TRUE;
			 default:
				break;
		  }
		}
		break;
	 case WM_INITDIALOG:
		hbrush=CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
		GetWindowRect(hdwnd,&drect);
		MoveWindow(hdwnd,((mainwnd.right+mainwnd.left)-(drect.right-drect.left))/2,
		  ((mainwnd.bottom+mainwnd.top)-(drect.bottom-drect.top))/2,drect.right-drect.left,drect.bottom-drect.top,TRUE);
		SetFocus(GetDlgItem(hdwnd,IDOK));
		return 0;
	 case WM_DESTROY:
		DeleteObject(hbrush);
		return 0;
	 case WM_CTLCOLORSTATIC:
	 case WM_CTLCOLORDLG:
	 case WM_SYSCOLORCHANGE:
		SetBkColor((HDC)wParam,GetSysColor(COLOR_BTNFACE));
		return (LRESULT)hbrush;
	 default:
		break;
  }
  return FALSE;
}
#pragma warn +par

void savedb(void)
{ int cbString,i;
  char chReplace;
  if(scheduler.sizelist())
  { MessageBox(mainwindow,"There are still items to process yet","Borg Warning",MB_OK|MB_ICONEXCLAMATION);
	 return;
  }
  GetCurrentDirectory(sizeof(szDirName),szDirName);
  szFilesave[0]=0;
  cbString=LoadString(hInst,IDS_FILTERSAVE,szFilter,sizeof(szFilter));
  chReplace=szFilter[cbString-1];
  for(i=0;szFilter[i]!=0;i++)
  { if(szFilter[i]==chReplace) szFilter[i]=0;
  }
  ofn.lStructSize=sizeof(OPENFILENAME);
  ofn.hwndOwner=mainwindow;
  ofn.lpstrFilter=szFilter;
  ofn.nFilterIndex=1;
  ofn.lpstrFile=szFilesave;
  ofn.nMaxFile=sizeof(szFilesave);
  ofn.lpstrFileTitle=szFileTitle;
  ofn.nMaxFileTitle=sizeof(szFileTitle);
  ofn.lpstrInitialDir=szDirName;
  ofn.lpstrCustomFilter=NULL;
  ofn.lpstrTitle="Borg Disassembler - Select File";
  ofn.Flags=OFN_PATHMUSTEXIST|OFN_HIDEREADONLY|OFN_LONGNAMES
				|OFN_EXPLORER;

  if(GetSaveFileName(&ofn))
  { floader.savedb(ofn.lpstrFile,szFile);
  }
}

void loaddb(void)
{ int cbString,i;
  char chReplace;
  GetCurrentDirectory(sizeof(szDirName),szDirName);
  szFilesave[0]=0;
  cbString=LoadString(hInst,IDS_FILTERSTRING,szFilter,sizeof(szFilter));
  chReplace=szFilter[cbString-1];
  for(i=0;szFilter[i]!=0;i++)
  { if(szFilter[i]==chReplace) szFilter[i]=0;
  }
  ofn.lStructSize=sizeof(OPENFILENAME);
  ofn.hwndOwner=mainwindow;
  ofn.lpstrFilter=szFilter;
  ofn.nFilterIndex=1;
  ofn.lpstrFile=szFilesave;
  ofn.nMaxFile=sizeof(szFilesave);
  ofn.lpstrFileTitle=szFileTitle;
  ofn.nMaxFileTitle=sizeof(szFileTitle);
  ofn.lpstrInitialDir=szDirName;
  ofn.lpstrCustomFilter=NULL;
  ofn.hInstance=NULL;
  ofn.lpTemplateName=NULL;
  ofn.lpstrTitle="Borg Disassembler - Select File";
  ofn.Flags=OFN_PATHMUSTEXIST|OFN_FILEMUSTEXIST|OFN_HIDEREADONLY|OFN_LONGNAMES
				|OFN_EXPLORER;
  if(GetOpenFileName(&ofn))
  { if(floader.loaddb(ofn.lpstrFile,szFile))
	 { StatusMessage("File Opened");
		strcat(winname," : ");
		strcat(winname,szFile);
		SetWindowText(mainwindow,winname);
		InThread=TRUE;
		ThreadHandle=CreateThread(NULL,0,(LPTHREAD_START_ROUTINE)Thread,0,0,&ThreadId);
		changemenus();
		scheduler.addtask(scrolling,priority_userrequest,nlptr,NULL);
	 }
	 else
		MessageBox(mainwindow,"File open failed ?",fname,MB_OK|MB_ICONEXCLAMATION);
  }
}

