//						data.cpp
//
//

#include <windows.h>

#include "data.h"
#include "proctab.h"
#include "schedule.h"
#include "disasm.h"
#include "dasm.h"
#include "debug.h"
#include "menuids.rh"

int dsegcfunc(listitem i,listitem j);
void dsegdfunc(listitem i);
BOOL FAR PASCAL segbox(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam);

dataseg::dataseg()
{ setcomparefunc(dsegcfunc);
  setdelfunc(dsegdfunc);
}

dataseg::~dataseg()
{
}

//compare function to order in list
int dsegcfunc(listitem i,listitem j)
{ if(((dsegitem *)i)->addr==((dsegitem *)j)->addr)
	 return 0;
  if(((dsegitem *)i)->addr>((dsegitem *)j)->addr)
	 return 1;
  return -1;
}

//deletion function for list
void dsegdfunc(listitem i)
{ if(((dsegitem *)i)->name!=NULL) delete ((dsegitem *)i)->name;
  if(((dsegitem *)i)->typ==uninitdata)delete ((dsegitem *)i)->data;
  delete(dsegitem *)i;
}

//add a block of data to list
// could be a segment or an object from a PE file
void dataseg::addseg(lptr loc,dword size,byte *dataptr,segtype t,char *name)
{ dsegitem *addit,*chker;
  char warning[100];
  dword tmpnum,tsize;
#ifdef DEBUG
  DebugMessage("Addseg %04lx:%04lx Size %04lx",loc.segm,loc.offs,size);
#endif
  addit=new dsegitem;
  addit->addr=loc;
  addit->size=size;
  addit->data=dataptr;
  addit->typ=t;
  if(name!=NULL)
  { addit->name=new char [strlen(name)+1];
	 strcpy(addit->name,name);
  }
  else addit->name=NULL;
  resetiterator();
  chker=(dsegitem *)nextiterator();
  while(chker!=NULL)
  { if((chker->addr.segm==addit->addr.segm)&&(chker->addr>=addit->addr)
		&&(chker->addr<addit->addr+addit->size))
	 { //need to cut addit short.
		addit->size=chker->addr-addit->addr;
		if(!addit->size)
		{ tmpnum=loc.segm;
		  wsprintf(warning,"Warning : Unable to create segment %04lx",tmpnum);
		  wsprintf(warning+strlen(warning),":%04lx",loc.offs);
		  wsprintf(warning+strlen(warning)," size :%04lx",size);
		  MessageBox(mainwindow,warning,"Borg Warning",MB_ICONEXCLAMATION|MB_OK);
		  return;
		}
		else
		{ tmpnum=loc.segm;
		  wsprintf(warning,"Warning : Segment overlap %04lx",tmpnum);
		  wsprintf(warning+strlen(warning),":%04lx",loc.offs);
		  wsprintf(warning+strlen(warning)," size :%04lx",size);
		  wsprintf(warning+strlen(warning)," reduced to size :%04lx",addit->size);
		  MessageBox(mainwindow,warning,"Borg Warning",MB_ICONEXCLAMATION|MB_OK);
		}
	 }
	 if((addit->addr.segm==chker->addr.segm)&&(addit->addr>=chker->addr)
		&&(addit->addr<(chker->addr+chker->size)))
	 { //need to cut chkit short.
		tsize=chker->size;
		chker->size=addit->addr-chker->addr;
		if(!chker->size)
		{ tmpnum=chker->addr.segm;
		  wsprintf(warning,"Warning : Unable to create segment %04lx",tmpnum);
		  wsprintf(warning+strlen(warning),":%04lx",chker->addr.offs);
		  wsprintf(warning+strlen(warning)," size :%04lx",tsize);
		  MessageBox(mainwindow,warning,"Borg Warning",MB_ICONEXCLAMATION|MB_OK);
		  delfrom((listitem)chker);
		  resetiterator();
		}
		else
		{ tmpnum=chker->addr.segm;
		  wsprintf(warning,"Warning : Segment overlap %04lx",tmpnum);
		  wsprintf(warning+strlen(warning),":%04lx",chker->addr.offs);
		  wsprintf(warning+strlen(warning)," size :%04lx",tsize);
		  wsprintf(warning+strlen(warning)," reduced to size :%04lx",chker->size);
		  MessageBox(mainwindow,warning,"Borg Warning",MB_ICONEXCLAMATION|MB_OK);
		}
	 }
	 chker=(dsegitem *)nextiterator();
  }
  addto((listitem)addit);
#ifdef DEBUG
  DebugMessage("Adding Seg %04lx:%04lx Size %04lx",loc.segm,loc.offs,size);
  if(name!=NULL)DebugMessage("Name:%s",name);
#endif
  scheduler.addtask(dis_segheader,priority_segheader,loc,NULL);
}

dsegitem *dataseg::findseg(lptr loc)
{ dsegitem t1;
  dsegitem *findd;
  t1.addr.segm=loc.segm;
  t1.addr.offs=0;
  findd=(dsegitem *)find((listitem)&t1);
  while(findd!=NULL)
  { if((findd->addr.segm==loc.segm)&&(loc<findd->addr+findd->size)&&(loc>=findd->addr))
		return findd;
	 findd=(dsegitem *)nextiterator();
  }
  return NULL;
}

BOOL dataseg::beyondseg(lptr loc)
{ dsegitem *findd;
  resetiterator();
  findd=(dsegitem *)nextiterator();
  while(findd!=NULL)
  { if((findd->addr.segm==loc.segm)&&(loc>=findd->addr)&&(loc<findd->addr+findd->size))
		return FALSE;
	 findd=(dsegitem *)nextiterator();
  }
  return TRUE;
}

void dataseg::nextseg(lptr *loc)
{ dsegitem *findd;
  resetiterator();
  findd=(dsegitem *)nextiterator();
  while(findd!=NULL)
  { if((findd->addr.segm==loc->segm)&&(*loc>findd->addr)&&(*loc<=findd->addr+findd->size+1))
	 { findd=(dsegitem *)nextiterator();
		if(findd==NULL) (loc->segm)=0;
		else (*loc)=findd->addr;
		return;
	 }
	 findd=(dsegitem *)nextiterator();
  }
}

void dataseg::lastseg(lptr *loc)
{ dsegitem *findd,*prevd;
  resetiterator();
  findd=(dsegitem *)nextiterator();
  prevd=NULL;
  while(findd!=NULL)
  { if((findd->addr.segm==loc->segm)&&(*loc+1>=findd->addr)&&(*loc+1<findd->addr+findd->size))
	 { if(prevd==NULL) (loc->segm)=0;
		else
		{ (*loc)=prevd->addr+prevd->size-1;
		}
		return;
	 }
	 prevd=findd;
	 findd=(dsegitem *)nextiterator();
  }
}

void dataseg::possibleentrycode(lptr loc)
{ dsegitem t1;
  dsegitem *findd;
  dword length;
  if(options.processor==PROC_Z80)return;
  t1.addr=loc;
  findd=(dsegitem *)find((listitem)&t1);
  if(findd==NULL) return;
  length=findd->size;
  loc.offs=findd->addr.offs;
  while(length)
  { if((options.codedetect&CD_PUSHBP)&&(length>3))
	 {  if(findd->data[loc-findd->addr]==0x55)  // push bp
		{ // two encodings of mov bp,sp
		  if((findd->data[(loc-findd->addr)+1]==0x8b)&&(findd->data[(loc-findd->addr)+2]==0xec))
			 scheduler.addtask(dis_code,priority_possiblecode,loc,NULL);
		  if((findd->data[(loc-findd->addr)+1]==0x89)&&(findd->data[(loc-findd->addr)+2]==0xe5))
			 scheduler.addtask(dis_code,priority_possiblecode,loc,NULL);
		}
	 }
	 if((options.codedetect&CD_ENTER)&&(length>4))
	 {  if(findd->data[loc-findd->addr]==0xc8)  // enter
		{ if(findd->data[(loc-findd->addr)+3]==0x00) // enter xx,00
			 scheduler.addtask(dis_code,priority_possiblecode,loc,NULL);
		}
	 }
	 if((options.codedetect&CD_MOVBX)&&(length>2)) // mov bx,sp
	 {  if((findd->data[loc-findd->addr]==0x8b)&&(findd->data[(loc-findd->addr)+1]==0xdc))
			scheduler.addtask(dis_code,priority_possiblecode,loc,NULL);
	 }
	 loc.offs++;
	 length--;
  }
}

void dataseg::segheader(lptr loc)
{ byte *tmpc,tmp2[30];
  dsegitem t1,*findd;
  dword t;
  t1.addr=loc;
  findd=(dsegitem *)find((listitem)&t1);
  if(findd==NULL)return;
  tmpc=new byte[80];
  strcpy((char *)tmpc,"-----------------------------------------------------------------------");
  dsm.discomment(loc,dsmsegheader,tmpc);
  tmpc=new byte[80];
  t=loc.segm;
  wsprintf((char *)tmpc,"Segment : %02lxh",t);
  wsprintf((char *)tmp2,"     Offset : %02lxh",loc.offs);
  strcat((char *)tmpc,(char *)tmp2);
  wsprintf((char *)tmp2,"     Size : %02lxh",findd->size);
  strcat((char *)tmpc,(char *)tmp2);
  dsm.discomment(loc,(dsmitemtype)(dsmsegheader+1),tmpc);
  tmpc=new byte[80];
  switch(findd->typ)
  { case code16:
		strcpy((char *)tmpc,"16-bit Code");
		break;
	 case code32:
		strcpy((char *)tmpc,"32-bit Code");
		break;
	 case data16:
		strcpy((char *)tmpc,"16-bit Data");
		break;
	 case data32:
		strcpy((char *)tmpc,"32-bit Data");
		break;
	 case uninitdata:
		strcpy((char *)tmpc,"Uninit Data");
		break;
	 case debugdata:
		strcpy((char *)tmpc,"Debug Data");
		break;
	 case resourcedata:
		strcpy((char *)tmpc,"Resource Data ");
		if(findd->name!=NULL) strcat((char *)tmpc,findd->name);
		break;
	 default:
		strcpy((char *)tmpc,"Unknown");
		break;
  }
  dsm.discomment(loc,(dsmitemtype)(dsmsegheader+2),tmpc);
  tmpc=new byte[80];
  strcpy((char *)tmpc,"-----------------------------------------------------------------------");
  dsm.discomment(loc,(dsmitemtype)(dsmsegheader+3),tmpc);
}

void dataseg::segviewer(void)
{ scheduler.stopthread();
  DialogBox(hInst,MAKEINTRESOURCE(Seg_Viewer),mainwindow,(DLGPROC)segbox);
  scheduler.continuethread();
}

#pragma warn -par
BOOL FAR PASCAL segbox(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam)
{ static HBRUSH hbrush;
  static string *segt;
  static char sstart[20],send[20],ssize[20],stype[20];
  static dsegitem *t;
  dword st;
  dword i;
  RECT drect;
  switch(message)
  { case WM_COMMAND:
		{	switch(wParam)
		  { case IDC_OKBUTTON:
				EndDialog(hdwnd,NULL);
				return TRUE;
			 case IDC_JUMPTOBUTTON:
				scheduler.addtask(user_jumptoaddr,priority_userrequest,t->addr,NULL);
				EndDialog(hdwnd,NULL);
				return TRUE;
			 default:
				break;
		  }
		  switch(HIWORD(wParam))
		  { case LBN_SELCHANGE:
				i=SendDlgItemMessage(hdwnd,IDC_SEGLISTBOX,LB_GETCURSEL,0,0);
				dta.resetiterator();
				t=(dsegitem *)dta.nextiterator();
				while(i)
				{ t=(dsegitem *)dta.nextiterator();
				  i--;
				}
				wsprintf(sstart,"0x%lx",t->addr.offs);
				st=t->addr.offs+t->size-1;
				wsprintf(send,"0x%lx",st);
				wsprintf(ssize,"0x%lx",t->size);
				switch(t->typ)
				{ case code16:
					 strcpy(stype,"16-bit Code");
					 break;
				  case code32:
					 strcpy(stype,"32-bit Code");
					 break;
				  case data16:
					 strcpy(stype,"16-bit Data");
					 break;
				  case data32:
					 strcpy(stype,"32-bit Data");
					 break;
				  case uninitdata:
					 strcpy(stype,"Uninit Data");
					 break;
				  case debugdata:
					 strcpy(stype,"Debug Data");
					 break;
				  case resourcedata:
					 strcpy(stype,"Resource Data");
					 break;
				  default:
					 strcpy(stype,"Unknown");
					 break;
				}
				SendDlgItemMessage(hdwnd,SEG_TEXTSTART,WM_SETTEXT,0,(LPARAM)(LPCTSTR)sstart);
				SendDlgItemMessage(hdwnd,SEG_TEXTEND,WM_SETTEXT,0,(LPARAM)(LPCTSTR)send);
				SendDlgItemMessage(hdwnd,SEG_TEXTSIZE,WM_SETTEXT,0,(LPARAM)(LPCTSTR)ssize);
				SendDlgItemMessage(hdwnd,SEG_TEXTTYPE,WM_SETTEXT,0,(LPARAM)(LPCTSTR)stype);
				SendDlgItemMessage(hdwnd,IDC_SEGNAMETEXT,WM_SETTEXT,0,(LPARAM)(LPCTSTR)t->name);
				break;
			 default:
				break;
		  }
		}
		break;
	 case WM_INITDIALOG:
		GetWindowRect(hdwnd,&drect);
		MoveWindow(hdwnd,((mainwnd.right+mainwnd.left)-(drect.right-drect.left))/2,
		  ((mainwnd.bottom+mainwnd.top)-(drect.bottom-drect.top))/2,drect.right-drect.left,drect.bottom-drect.top,TRUE);
		segt=new string[dta.numlistitems()];
		dta.resetiterator();
		for(i=0;i<dta.numlistitems();i++)
		{ segt[i]=new char[20];
		  t=(dsegitem *)dta.nextiterator();
		  st=t->addr.segm;
		  wsprintf(segt[i],"0x%x",st);
		  st=t->addr.offs;
		  wsprintf(segt[i]+strlen(segt[i]),":0x%04lx",st);
		  SendDlgItemMessage(hdwnd,IDC_SEGLISTBOX,LB_ADDSTRING,0,(LPARAM) (LPCTSTR)segt[i]);
		}
		SendDlgItemMessage(hdwnd,IDC_SEGLISTBOX,LB_SETCURSEL,0,0);
		dta.resetiterator();
		t=(dsegitem *)dta.nextiterator();
		wsprintf(sstart,"0x%lx",t->addr.offs);
		st=t->addr.offs+t->size-1;
		wsprintf(send,"0x%lx",st);
		wsprintf(ssize,"0x%lx",t->size);
		switch(t->typ)
		{ case code16:
			 strcpy(stype,"16-bit Code");
			 break;
		  case code32:
			 strcpy(stype,"32-bit Code");
			 break;
		  case data16:
			 strcpy(stype,"16-bit Data");
			 break;
		  case data32:
			 strcpy(stype,"32-bit Data");
			 break;
		  case uninitdata:
			 strcpy(stype,"Uninit Data");
			 break;
		  case debugdata:
			 strcpy(stype,"Debug Data");
			 break;
		  case resourcedata:
			 strcpy(stype,"Resource Data");
			 break;
		  default:
			 strcpy(stype,"Unknown");
			 break;
		}
		SendDlgItemMessage(hdwnd,SEG_TEXTSTART,WM_SETTEXT,0,(LPARAM)(LPCTSTR)sstart);
		SendDlgItemMessage(hdwnd,SEG_TEXTEND,WM_SETTEXT,0,(LPARAM)(LPCTSTR)send);
		SendDlgItemMessage(hdwnd,SEG_TEXTSIZE,WM_SETTEXT,0,(LPARAM)(LPCTSTR)ssize);
		SendDlgItemMessage(hdwnd,SEG_TEXTTYPE,WM_SETTEXT,0,(LPARAM)(LPCTSTR)stype);
		SendDlgItemMessage(hdwnd,IDC_SEGNAMETEXT,WM_SETTEXT,0,(LPARAM)(LPCTSTR)t->name);
		hbrush=CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
		SetFocus(GetDlgItem(hdwnd,IDC_OKBUTTON));
		return 0;
	 case WM_DESTROY:
		for(i=0;i<dta.numlistitems();i++)
		{ SendDlgItemMessage(hdwnd,IDC_SEGLISTBOX,LB_DELETESTRING,(WPARAM)(dta.numlistitems()-i-1),0);
		  delete segt[dta.numlistitems()-i-1];
		}
		delete segt;
		DeleteObject(hbrush);
		return 0;
	 case WM_CTLCOLORSTATIC:
	 case WM_CTLCOLORBTN:
	 case WM_CTLCOLORDLG:
	 case WM_SYSCOLORCHANGE:
		SetBkColor((HDC)wParam,GetSysColor(COLOR_BTNFACE));
		return (LRESULT)hbrush;
  }
  return FALSE;
}
#pragma warn +par

BOOL dataseg::savedb(HANDLE sfile,byte *filebuff)
{ dword nsegs,num,nlen;
  dsegitemsave structsave;
  dsegitem *currseg;
  nsegs=numlistitems();
  resetiterator();
  if(!WriteFile(sfile,&nsegs,sizeof(dword),&num,NULL))return FALSE;
  while(nsegs)
  { currseg=(dsegitem *)nextiterator();
	 structsave.addr=currseg->addr;
	 structsave.size=currseg->size;
	 structsave.fileoffset=currseg->data-filebuff;
	 structsave.typ=currseg->typ;
	 if(currseg->name!=NULL) structsave.name=TRUE;
	 else structsave.name=FALSE;
	 if(!WriteFile(sfile,&structsave,sizeof(dsegitemsave),&num,NULL))return FALSE;
	 if(structsave.name)
	 { nlen=strlen(currseg->name)+1;
		if(!WriteFile(sfile,&nlen,sizeof(dword),&num,NULL))return FALSE;
		if(!WriteFile(sfile,currseg->name,nlen,&num,NULL))return FALSE;
	 }
	 nsegs--;
  }
  return TRUE;
}

BOOL dataseg::loaddb(HANDLE sfile,byte *filebuff)
{ dword nsegs,num,nlen;
  dsegitemsave structsave;
  dsegitem *currseg;
  if(!ReadFile(sfile,&nsegs,sizeof(dword),&num,NULL))return FALSE;
  while(nsegs)
  { currseg=new dsegitem;
	 if(!ReadFile(sfile,&structsave,sizeof(dsegitemsave),&num,NULL))return FALSE;
	 currseg->addr=structsave.addr;
	 currseg->size=structsave.size;
	 currseg->data=structsave.fileoffset+filebuff;
	 currseg->typ=structsave.typ;
	 if(structsave.name)
	 { if(!ReadFile(sfile,&nlen,sizeof(dword),&num,NULL))return FALSE;
		currseg->name=new char[nlen];
		if(!ReadFile(sfile,currseg->name,nlen,&num,NULL))return FALSE;
	 }
	 else currseg->name=FALSE;
	 if(currseg->typ==uninitdata)
	 { currseg->data=new byte[currseg->size];
		for(nlen=0;nlen<currseg->size;nlen++)
        (currseg->data)[nlen]=0;
	 }
	 addto((listitem)currseg);
	 nsegs--;
  }
  return TRUE;
}

