//			gname.cpp
//
// generic named locations class, used by exports,imports and names classes
// - Added build 16.

#include <windows.h>

#include "gname.h"
#include "disasm.h"
#include "mainwind.h"

int gnamecfunc(listitem i,listitem j);
void gnamedfunc(listitem i);

// constructor - sets up compare and deletion functions for the list base class.
gname::gname()
{ setcomparefunc(gnamecfunc);
  setdelfunc(gnamedfunc);
}

gname::~gname()
{
}

//compare function to order in list
int gnamecfunc(listitem i,listitem j)
{ if(((gnameitem *)i)->addr==((gnameitem *)j)->addr)
	 return 0;
  if(((gnameitem *)i)->addr>((gnameitem *)j)->addr)
	 return 1;
  return -1;
}

//deletion function for list
void gnamedfunc(listitem i)
{ // delete name.
  delete ((gnameitem *)i)->name;
  // delete gnameitem.
  delete (gnameitem *)i;
}

// adds an item to the gname list.
void gname::addname(lptr loc,char *nm)
{ gnameitem *newname,*checkdup;
  if(!dsm.oktoname(loc))return; // check not in the middle of an instruction.
  newname=new gnameitem;
  newname->name=new char[strlen(nm)+1];
  strcpy(newname->name,nm);
  demangle(&newname->name);
  newname->addr=loc;
  checkdup=(gnameitem *)find((listitem)newname);
  // just add it once.
  if(checkdup!=NULL)
	 if(checkdup->addr==loc)
	 { delete checkdup->name;
		checkdup->name=newname->name;
		delete newname;
		dsm.delcomment(loc,dsmnameloc);
		if(strlen(checkdup->name))
		  dsm.discomment(loc,dsmnameloc,(byte *)checkdup->name);
		else
		{ delfrom((listitem)checkdup);
		}
		return;
	 }
  if(!strlen(newname->name))
  { // bugfix by Mark Ogden
	 delete newname->name;
    delete newname; 
    return;
  }
  addto((listitem)newname);
  dsm.discomment(loc,dsmnameloc,(byte *)newname->name);
  // NB - no need for this anymore. Need to ensure that
  // printing of names is done as :
  // if names.isname() ...
  // else if imports.isname()...
  // else if expoert.isexport()...
  // so names aren't printed twice, and import names,etc are retained always 
  //if(dta.findseg(loc)!=NULL)name.addname(loc,nm);
}

// return true if the location loc is an named location.
BOOL gname::isname(lptr loc)
{ gnameitem checkit,*findit;
  checkit.addr=loc;
  findit=(gnameitem *)find((listitem)&checkit);
  if(findit!=NULL) if(findit->addr==loc) return TRUE;
  return FALSE;
}

// output name of loc
// used with previous function, if(isname(loc))printname(loc),etc
void gname::printname(lptr loc)
{ gnameitem checkit,*findit;
  checkit.addr=loc;
  findit=(gnameitem *)find((listitem)&checkit);
  if(findit!=NULL) LastPrintBuff("%s",findit->name);
}

void gname::delname(lptr loc)
{ gnameitem dname,*checkdup;
  dname.addr=loc;
  checkdup=(gnameitem *)find((listitem)&dname);
  if(checkdup!=NULL)
	 if(checkdup->addr==loc)
		delfrom((listitem)checkdup);
  dsm.delcomment(loc,dsmnameloc);
}

// saves gname list to database.
// - first number of items
// - then each item ( address,name )
// - each name writes length first.
BOOL gname::savedb(HANDLE sfile)
{ dword nexps,num,nlen;
  gnameitem *currexp;
  nexps=numlistitems();
  resetiterator();
  if(!WriteFile(sfile,&nexps,sizeof(dword),&num,NULL))return FALSE;
  while(nexps)
  { currexp=(gnameitem *)nextiterator();
	 if(!WriteFile(sfile,&(currexp->addr),sizeof(lptr),&num,NULL))return FALSE;
	 nlen=strlen(currexp->name)+1;
	 if(!WriteFile(sfile,&nlen,sizeof(dword),&num,NULL))return FALSE;
	 if(!WriteFile(sfile,currexp->name,nlen,&num,NULL))return FALSE;
	 nexps--;
  }
  return TRUE;
}

// loads gname list from database file.
BOOL gname::loaddb(HANDLE sfile)
{ dword nexps,num,nlen;
  gnameitem *currexp;
  if(!ReadFile(sfile,&nexps,sizeof(dword),&num,NULL))return FALSE;
  while(nexps)
  { currexp=new gnameitem;
	 if(!ReadFile(sfile,&(currexp->addr),sizeof(lptr),&num,NULL))return FALSE;
	 if(!ReadFile(sfile,&nlen,sizeof(dword),&num,NULL))return FALSE;
	 currexp->name=new char[nlen];
	 if(!ReadFile(sfile,currexp->name,nlen,&num,NULL))return FALSE;
	 addto((listitem)currexp);
	 nexps--;
  }
  return TRUE;
}

#pragma warn -par
// null function - overridden by import class.
void gname::demangle(char **name)
{
}
#pragma warn +par
