//						search.cpp
//
// search routines

#include <windows.h>
#include <stdio.h>

#include "menuids.rh"
#include "srch.h"
#include "data.h"
#include "schedule.h"
#include "disasm.h"
#include "debug.h"
#include "dasm.h"

BOOL FAR PASCAL searchbox(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam);
BOOL FAR PASCAL searchingbox(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam);

void searchengine(void)
{ scheduler.stopthread();
  DialogBox(hInst,MAKEINTRESOURCE(Search_Dialog),mainwindow,(DLGPROC)searchbox);
  scheduler.continuethread();
}

#pragma warn -par
BOOL FAR PASCAL searchbox(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam)
{ static HBRUSH hbrush;
  search_type searchtype;
  char srchtext[200];
  byte match[200];
  dsegitem *srchseg;
  int matchlen,i;
  byte tmpbyte;
  byte *segmtch;
  dword mtch;
  lptr s_seg;
  RECT drect;
  BOOL found;
  HWND sbox;
  BOOL fromstart;  // added plus code, bug fix build 14
  switch(message)
  { case WM_COMMAND:
		{	switch(wParam)
		  { case IDOK:
				if(SendDlgItemMessage(hdwnd,search_string,BM_GETCHECK,(WPARAM)0,(LPARAM)0))
				  searchtype=SEARCH_STR;
				else if(SendDlgItemMessage(hdwnd,search_hex,BM_GETCHECK,(WPARAM)0,(LPARAM)0))
				  searchtype=SEARCH_HEX;
				else if(SendDlgItemMessage(hdwnd,search_decimal,BM_GETCHECK,(WPARAM)0,(LPARAM)0))
				  searchtype=SEARCH_DEC;
				else searchtype=SEARCH_BYTES;
				if(SendDlgItemMessage(hdwnd,search_fromstart,BM_GETCHECK,(WPARAM)0,(LPARAM)0))
				{ s_seg=options.loadaddr;
				  fromstart=TRUE;
				}
				else
				{ dsm.findcurrentaddr(&s_seg);
				  s_seg+=dsm.getlength(s_seg);
				  fromstart=FALSE;
				}
				sbox=CreateDialog(hInst,MAKEINTRESOURCE(S_Box),hdwnd,(DLGPROC)searchingbox);
				// get string,
				SendDlgItemMessage(hdwnd,search_edit,WM_GETTEXT,(WPARAM)18,(LPARAM)srchtext);
				switch(searchtype)
				{ case SEARCH_STR:
					 matchlen=strlen(srchtext);
					 strcpy((char *)match,srchtext);
					 break;
				  case SEARCH_HEX:
					 sscanf(srchtext,"%x",&mtch);
					 if(mtch<256)
					 { matchlen=1;
						match[0]=(byte)mtch;
					 }
					 else if(mtch<65536)
					 { matchlen=2;
						match[0]=(byte)(mtch&0xff);
						match[1]=(byte)(mtch/0x100);
					 }
					 else
					 { matchlen=4;
						match[0]=(byte)(mtch&0xff);
						match[1]=(byte)(mtch/0x100);
						match[2]=(byte)(mtch/0x10000);
						match[3]=(byte)(mtch/0x1000000);
					 }
					 break;
				  case SEARCH_DEC:
					 sscanf(srchtext,"%d",&mtch);
					 if(mtch<256)
					 { matchlen=1;
						match[0]=(byte)mtch;
					 }
					 else if(mtch<65536)
					 { matchlen=2;
						match[0]=(byte)(mtch&0xff);
						match[1]=(byte)(mtch/0x100);
					 }
					 else
					 { matchlen=4;
						match[0]=(byte)(mtch&0xff);
						match[1]=(byte)(mtch/0x100);
						match[2]=(byte)(mtch/0x10000);
						match[3]=(byte)(mtch/0x1000000);
					 }
					 break;
				  case SEARCH_BYTES:
					 matchlen=strlen(srchtext)/2;
					 for(i=0;i<matchlen;i++)
					 { if(srchtext[i*2]>='a')tmpbyte=(byte)((srchtext[i*2]-'a'+10));
						else tmpbyte=(byte)((srchtext[i*2]-'0'));
						if(srchtext[i*2+1]>='a')tmpbyte=(byte)(tmpbyte*16+(srchtext[i*2+1]-'a'+10));
						else tmpbyte=(byte)(tmpbyte*16+(srchtext[i*2+1]-'0'));
						match[i]=tmpbyte;
					 }
					 break;
				}
				// string->data,
				// for each seg do .....
				found=FALSE;
				if(fromstart)
				{ dta.resetiterator();
				  srchseg=(dsegitem *)dta.nextiterator();
				  dta.resetiterator();
				}
				else
				  srchseg=dta.findseg(s_seg);
				while(srchseg!=NULL)
				{ s_seg.segm=srchseg->addr.segm;
				  if(s_seg<srchseg->addr)s_seg=srchseg->addr;
				  while(s_seg<srchseg->addr+srchseg->size-matchlen)
				  { segmtch=srchseg->data+(s_seg-srchseg->addr);
					 found=TRUE;
					 for(i=0;i<matchlen;i++)
					 { if(segmtch[i]!=match[i])
						{ found=FALSE;
						  break;
						}
					 }
					 if(found)break;
					 s_seg++;
				  }
				  if(found)break;
				  s_seg.offs=0;
				  srchseg=(dsegitem *)dta.nextiterator();
				}
				if(found)scheduler.addtask(user_jumptoaddr,priority_userrequest,s_seg,NULL);
				DestroyWindow(sbox);
				EndDialog(hdwnd,NULL);
				return TRUE;
			 case IDCANCEL:
				EndDialog(hdwnd,NULL);
				return TRUE;
			 default:
				break;
		  }
		}
		break;
	 case WM_INITDIALOG:
		GetWindowRect(hdwnd,&drect);
		MoveWindow(hdwnd,((mainwnd.right+mainwnd.left)-(drect.right-drect.left))/2,
		  ((mainwnd.bottom+mainwnd.top)-(drect.bottom-drect.top))/2,drect.right-drect.left,drect.bottom-drect.top,TRUE);
		hbrush=CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
		SendDlgItemMessage(hdwnd,search_string,BM_SETCHECK,(WPARAM)1,(LPARAM)0);
		SendDlgItemMessage(hdwnd,search_fromcurr,BM_SETCHECK,(WPARAM)1,(LPARAM)0);
		SetFocus(GetDlgItem(hdwnd,search_edit));
		return 0;
	 case WM_DESTROY:
		DeleteObject(hbrush);
		return 0;
	 case WM_CTLCOLORSTATIC:
	 case WM_CTLCOLORBTN:
	 case WM_CTLCOLORDLG:
	 case WM_SYSCOLORCHANGE:
		SetBkColor((HDC)wParam,GetSysColor(COLOR_BTNFACE));
		return (LRESULT)hbrush;
  }
  return FALSE;
}
#pragma warn +par

#pragma warn -par
BOOL FAR PASCAL searchingbox(HWND hdwnd,UINT message,WPARAM wParam,LPARAM lParam)
{ static HBRUSH hbrush;
  RECT drect;
  switch(message)
  { case WM_INITDIALOG:
		hbrush=CreateSolidBrush(GetSysColor(COLOR_BTNFACE));
		GetWindowRect(hdwnd,&drect);
		MoveWindow(hdwnd,((mainwnd.right+mainwnd.left)-(drect.right-drect.left))/2,
		  ((mainwnd.bottom+mainwnd.top)-(drect.bottom-drect.top))/2,drect.right-drect.left,drect.bottom-drect.top,TRUE);
		return 0;
	 case WM_DESTROY:
		DeleteObject(hbrush);
		return 0;
	 case WM_CTLCOLORSTATIC:
	 case WM_CTLCOLORDLG:
	 case WM_SYSCOLORCHANGE:
		SetBkColor((HDC)wParam,GetSysColor(COLOR_BTNFACE));
		return (LRESULT)hbrush;
  }
  return FALSE;
}
#pragma warn +par
