COMMENT $
I present here a complete implementation of a Procdump Bhrama client
for Petite 2.1.
The latest version of Petite uses the simple but effective trick of
redirection stubs to screw up Procdump's (> 1.x) imports rebuilder: 
the basic idea is that an IAT scanner can't handle automatically 
a non exported address... moreever the Procdump rebuilder works
only at predump time ('coz it can't handle the nasty fake stubs that 
WinSlow create for r3 appz that are under debugging..) when scripts 
are ineffective...btw the most interesting thing of sources is imho
the very simple r3 tracer implemented using the power of exceptions 
& context manipulation.
The following sources are part of a tutorial on manual unpacking
that i've written for the RingZ3r0 R.E. site (http://ringzer0.cjb.net).

best regards,
              Kill3xx
$

.586
.MODEL FLAT, STDCALL
OPTION CASEMAP :NONE   

INCLUDE \USER\W32ASM\MASM\INCLUDE\WINDOWS.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\KERNEL32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\USER32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\GDI32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\COMCTL32.INC
INCLUDE \USER\W32ASM\MASM\INCLUDE\COMDLG32.INC

INCLUDELIB \USER\W32ASM\MASM\LIB\KERNEL32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\USER32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\GDI32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\COMCTL32.LIB
INCLUDELIB \USER\W32ASM\MASM\LIB\COMDLG32.LIB      
     
      
return MACRO arg
  mov eax,arg
 ret
ENDM

wsprintfA           PROTO C :DWORD, :VARARG
wsprintf            TEXTEQU <wsprintfA>
WinMain             PROTO :DWORD,:DWORD,:DWORD,:SDWORD
ErrorMessage        PROTO :DWORD
FindModuleBase      PROTO :DWORD,:DWORD
ExtractModuleName   PROTO :DWORD,:DWORD
_strcpy             PROTO :DWORD,:DWORD
_strlen             PROTO :DWORD

DISPACTH_ENTRY STRUCT 
 cbActions         WORD  ? 
 dwMsgBase         DWORD ?
 tActionTable      DWORD ?
DISPACTH_ENTRY ENDS

.CONST

cMMFromPageFile EQU -1

CLI_NOTIFY  = WM_USER+1
CLI_SERVICE = WM_USER+2
NTF_LAYER1    = 00000000 
NTF_LAYER2    = 00000001 
NTF_BPX0      = 00000002 
NTF_BPX1      = 00000003 
NTF_BPX2      = 00000004 
NTF_BPX3      = 00000005 
ERR_NOSERVER  = -1
ERR_WRONGVER  = -2

            
DR7_MASK_ON   = 1000000001b    ; DR0 x + LE
DR7_MASK_OFF  = 0


INCLUDE PTCLIENT.INC      

.DATA

szProgramName                 DB "Petite 2.1 Brahma Client",0
szBhrama                      DB "ProcDump32 - Dumper Server",0
szSuccess                     DB "Target successfully dumped.",0
szFailed                      DB "Tracer failure : can't dump target process.",0
szCreateProc                  DB "LOADER -> creating process",0
szCheckSign                   DB "LOADER -> checking signature",0
szOfnFilter                   DB "Executable Files",0,"*.exe",0,"All Files",0,"*.*",0,0
szGeneralError                DB "Unexpected application error : bye bye...", 0
szGenErrMsg                   DB "An error has occured: unable to complete operation",0 
szAboutMsg                    DB 09,"Petite 2.1 Brahma Client",09,0Ah,0Dh,0Ah,0Dh
                              DB 09,"by Kill3xx for RingZ3r0",09,0Ah,0Dh,0
szKernel32                    DB "KERNEL32",0
szUser32                      DB "USER32",0
szOpenFileMappingA            DB "OpenFileMappingA",0
szMapViewOfFile               DB "MapViewOfFile",0
szExitProcess                 DB "ExitProcess",0
szGetCurrentProcess           DB "GetCurrentProcess",0
szGetCurrentThread            DB "GetCurrentThread",0
szSetUnhandledExceptionFilter DB "SetUnhandledExceptionFilter",0
szFlushInstructionCache       DB "FlushInstructionCache",0
szSuspendThread               DB "SuspendThread",0
szFindWindowA                 DB "FindWindowA",0
szSendMessageA                DB "SendMessageA",0
szPostMessageA                DB "PostMessageA",0

ALIGN DWORD
DispatchTable  DISPACTH_ENTRY <3,IDM_MAIN_BASE+1,offset tAct_Main>
DispatchTableL EQU ($-DispatchTable)/SIZEOF DISPACTH_ENTRY

ALIGN DWORD
tAct_Main     DD     offset doBrowse
              DD     offset doLoad
              DD     offset doAbout

szLayer1      DB "TRACER -> first layer reached",09,": EIP=0x%lX",0
szLayer2      DB "TRACER -> second layer reached",09,": EIP=0x%lX",0
szBpx0        DB "TRACER -> third layer BPX #0",09,": EIP=0x%lX",0
szBpx1        DB "TRACER -> third layer BPX #1",09,": EIP=0x%lX",0
szBpx2        DB "TRACER -> third layer BPX #2",09,": EIP=0x%lX",0
szBpx3        DB "TRACER -> third layer BPX #3",09,": EIP=0x%lX",0
szError1      DB "ERROR  -> server window not found",0
szError2      DB "ERROR  -> Incorrect Version",0

tblDecodeMsg  DD  offset szLayer1
              DD  offset szLayer2
              DD  offset szBpx0
              DD  offset szBpx1
              DD  offset szBpx2
              DD  offset szBpx3

BHR_Ver       DD 00000003h
BHR_pid       DD 00000000h
BHR_eip       DD 00000000h
OPTL1         DD 00000000h
OPTL2         DD 01010001h
OPTL3         DD 01010001h
OPTL4         DD 00030100h
OPTL5         DD 00000000h

BHR_Service   DD  00000001h
              DD  00000020h
              DD  offset BHR_Ver

.DATA?

szFilePath    DB     MAX_PATH dup (?)
szStrBuffer   DB     260 dup (?)
szStrBufferl  EQU    ($-szStrBuffer)-1
szCommandLine TEXTEQU <szStrBuffer>
szCurrentDir  DB     MAX_PATH dup (?)

hInstance     HANDLE ?
hMain         HWND   ?
hBhrama       HWND   ?
hLoadBtn      HWND   ?
hFileMap      HANDLE ?
OFN           OPENFILENAME        <?>
pif           PROCESS_INFORMATION <?>
sif           STARTUPINFO <?>
ThreadID      DD     ?
cbBytes       DD     ?
Dumped        DD     ?

 
.CODE

;---- START INJECTED CODE ---------------------------------------------------------------
; enable writable section flag  (link /SECTION:.text,RW)
Gate:   push eax
        pushad
        call   _d1
_d1:    pop    ebp
        sub    ebp,(_d1-Gate)
        lea    eax,[(szGateKeeper-Gate)+ebp]
        push   eax
        push   FALSE
        push   FILE_MAP_ALL_ACCESS
        call   dword ptr [(_OpenFileMappingA-Gate)+ebp]
        xor    edx,edx
        push   edx
        push   edx  ; map our MMF into process address space
        push   edx
        push   FILE_MAP_ALL_ACCESS
        push   eax
        call   dword ptr [(_MapViewOfFile-Gate)+ebp]
        .IF    eax!=0   
          mov   [esp+20h],ebp
          mov   edi,ebp
          jmp   eax     ; jump to our loader
        .ENDIF     
        push   -1       ; umm... something goes wrong
        call   dword ptr [(_ExitProcess-Gate)+ebp]         
        
        szGateKeeper           DB 'CARONTE',0        
        _OpenFileMappingA      DD 0
        _MapViewOfFile         DD 0
        _ExitProcess           DD 0

GateSize = $-Gate

Injected:
        call   _d2
_d2:    pop    ebp      
        sub    ebp,(_d2-Injected)
        lea    eax,[(szClassName-Injected)+ebp]
        push   0
        push   eax   ; get window handle of our server
        call   dword ptr [(_FindWindowA-Injected)+ebp]
        .IF eax!=0    
           mov    [(hServer-Injected)+ebp],eax
           lea    eax,[(_xHandler-Injected)+ebp]
           xchg   eax,[(xOHandler-Injected)+ebp]
           mov    [(xHandler-Injected)+ebp],eax
           mov    ebx,edi
           mov    eax,NTF_LAYER1
        .ELSE
           mov    eax,ERR_NOSERVER
        .ENDIF  
        push   ebx
        push   eax
        push   CLI_NOTIFY
        push   [(hServer-Injected)+ebp]
        call   dword ptr [(_SendMessageA-Injected)+ebp]
        lea    esi,[(EntryPoint-Injected)+ebp]
        mov    ecx,GateSize    ; restore original code
        rep    movsb
        call   dword ptr [(_GetCurrentProcess-Injected)+ebp]
        push   ecx
        push   ecx
        push   eax
        call   dword ptr [(_FlushInstructionCache-Injected)+ebp]
        popa
       ret

; our 
_xHandler:
        call   _d3
_d3:    pop    ebp
        sub    ebp,(_d3-Injected)
        mov    ebx,[(xHandler-Injected)+ebp]
        .IF  (dword ptr [ebx+6Ah]==81243C8Bh) && (dword ptr [ebx+22Ch]==257D2824h)
          lea    eax,[(xTracer-Injected)+ebp]
          push   eax    ; install our tracer
          call   dword ptr [(_SetUnhandledExceptionFilter-Injected)+ebp]
          mov    byte ptr  [ebx+6Ah],0CCh   ; bpx on _layer3
          mov    eax,NTF_LAYER2
        .ELSE  
          mov    eax,ERR_WRONGVER
        .ENDIF  
        push   ebx
        push   eax
        push   CLI_NOTIFY
        push   [(hServer-Injected)+ebp]
        call   dword ptr [(_SendMessageA-Injected)+ebp]
        jmp    ebx     ; call _layer3

; r3 tracer -> follow 3rd & 4th petite's layers execution
xTracer PROC   USES ebx esi edi ebp
        xPointers EQU (ESP+4+4*4)
        
        call   _d4
_d4:    pop    ebp
        sub    ebp,(_d4-Injected)
        mov    ebx,[xPointers]
        mov    esi,[ebx]
        mov    edi,[ebx+4]
        mov    ecx,[esi].EXCEPTION_RECORD.ExceptionFlags
        jecxz  _bpx
        xor    eax,eax ; EXCEPTION_CONTINUE_SEARCH
        jmp    _skip
_bpx:   mov    ebx,[esi].EXCEPTION_RECORD.ExceptionAddress
        mov    ecx,dword ptr [(cLevel-Injected)+ebp]
        jecxz  _bpx0
        dec    ecx
        jz     _bpx1
        dec    ecx
        jz     _bpx2
        dec    ecx
        jz     _bpx3
        jmp    _skip
_bpx0:  ; _layer3 -> set bpm on stub randomizer
        dec    ebx     
        mov    byte ptr [ebx],8Bh
        lea    eax,[ebx+1C4h]
        mov    [edi].CONTEXT.iDr0,eax
        mov    [edi].CONTEXT.iDr7,DR7_MASK_ON
        push   ebx
        push   NTF_BPX0
        push   CLI_NOTIFY
        push   [(hServer-Injected)+ebp]
        call   dword ptr [(_SendMessageA-Injected)+ebp]
        inc    dword ptr [(cLevel-Injected)+ebp]
        jmp    _reload
_bpx1:  ; layer3 -> patch stub randomizer + bpm on call _layer4
        mov    byte ptr [ebx],0EBh
;        mov    word ptr [ebx+31h],9090h
;        mov    word ptr [ebx+48h],04EBh
        lea    eax,[ebx+12Ch]
        mov    [edi].CONTEXT.iDr0,eax
        mov    [edi].CONTEXT.iDr7,DR7_MASK_ON
        push   ebx
        push   NTF_BPX1
        push   CLI_NOTIFY
        push   [(hServer-Injected)+ebp]
        call   dword ptr [(_SendMessageA-Injected)+ebp]
        inc    dword ptr [(cLevel-Injected)+ebp]
        jmp    _reload
_bpx2:  ; call _layer4 -> walk
        mov    [edi].CONTEXT.iDr7,DR7_MASK_OFF
        or     [edi].CONTEXT.regFlag,100h
        push   ebx
        push   NTF_BPX2
        push   CLI_NOTIFY
        push   [(hServer-Injected)+ebp]
        call   dword ptr [(_SendMessageA-Injected)+ebp]
        inc    dword ptr [(cLevel-Injected)+ebp]
        jmp    _reload
_bpx3:  ; _layer4 -> get EP -> dump

        push   NTF_BPX3
        push   CLI_NOTIFY
        push   [(hServer-Injected)+ebp]
        call   dword ptr [(_SendMessageA-Injected)+ebp]
        push   ebx
        xor    eax,eax
        mov    ax,word ptr [ebx+12]
        mov    dx,word ptr [ebx+10]
        shl    eax,16
        mov    ax,dx
        lea    eax,[eax+ebx+14]
        push   eax
        push   eax
        push   CLI_SERVICE
        push   [(hServer-Injected)+ebp]
        call   dword ptr [(_SendMessageA-Injected)+ebp]
        inc    dword ptr [(cLevel-Injected)+ebp]
_reload:        
        mov    [edi].CONTEXT.regEip,ebx
        mov    [edi].CONTEXT.ContextFlags,CONTEXT_FULL \    ; reload context
                            + CONTEXT_DEBUG_REGISTERS       ; and continue excution at the same EIP
        mov    eax,EXCEPTION_CONTINUE_EXECUTION                            
_skip:  
      ret       
xTracer ENDP

        szClassName                  DB "PTCLIENTCLASS",0
        xHandler                     DD 0
        hServer                      DD 0
        cLevel                       DD 0

        _GetCurrentProcess           DD 0
        _SetUnhandledExceptionFilter DD 0
        _FlushInstructionCache       DD 0
        _SuspendThread               DD 0
        _FindWindowA                 DD 0
        _SendMessageA                DD 0

EntryPoint                           DB  8 dup (0)
xOHandler                            DD  0
                                     DB  150 dup (0)
InjectSize = $-Injected


;---- START LOADER CODE ---------------------------------------------------------------

xTermHandler:
        invoke   MessageBeep,-1
        invoke   MessageBox,NULL,ADDR szGeneralError,ADDR szProgramName,MB_ICONHAND
        invoke   ExitProcess,-1

        ASSUME  fs:nothing
start:
        invoke   SetUnhandledExceptionFilter,offset xTermHandler 
        invoke   GetModuleHandle,NULL
        mov      [hInstance],eax
        invoke   WinMain,[hInstance],NULL,NULL,SW_SHOWDEFAULT
        invoke   ExitProcess,eax
    
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:SDWORD
        
         LOCAL wc   :WNDCLASSEX
         LOCAL msg  :MSG
         LOCAL hWnd :HANDLE

         mov    [wc].cbSize,sizeof WNDCLASSEX
         mov    [wc].style,CS_HREDRAW + CS_VREDRAW
         mov    [wc].lpfnWndProc,offset WndProc
         mov    [wc].cbClsExtra,0
         mov    [wc].cbWndExtra,DLGWINDOWEXTRA
         mov    [wc].hInstance,eax
         invoke LoadIcon,eax,IDI_ICON
         mov    [wc].hIcon,eax
         mov    [wc].hIconSm,eax
         invoke LoadCursor,NULL,IDC_ARROW
         mov    [wc].hCursor,eax
         mov    [wc].hbrBackground,COLOR_BACKGROUND
         mov    [wc].lpszMenuName,NULL
         mov    [wc].lpszClassName,offset  szClassName
         invoke RegisterClassEx,ADDR wc
         invoke CreateDialogParam,[hInst],ADDR szClassName,0,NULL,0     
         mov    [hWnd],eax
         invoke GetDlgItem,[hWnd],IDC_LOAD
         mov    [hLoadBtn],eax
         invoke EnableWindow,eax,FALSE
         .WHILE TRUE
            invoke GetMessage,ADDR msg,NULL,0,0
            .BREAK .IF (!eax)
            invoke TranslateMessage,ADDR msg
            invoke DispatchMessage,ADDR msg
         .ENDW
         return msg.wParam
        ret 
WinMain ENDP


WndProc PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
                  
         .IF [uMsg]==WM_COMMAND
           mov   ebx,[wParam]
           and   ebx,0FFFFh
           mov   ecx,DispatchTableL
           mov   edi,offset DispatchTable
_do:         
           movzx edx,word ptr [edi].DISPACTH_ENTRY.cbActions
           mov   eax,[edi].DISPACTH_ENTRY.dwMsgBase
           add   edx,eax
           cmp   ebx,eax
           jl    _next
           cmp   ebx,edx
           ja    _next
           jmp   _dispatch
_next:         
           add   edi,sizeof DISPACTH_ENTRY
           dec   ecx
           jnz   _do
           jmp   _quit
_dispatch:
           sub   ebx,eax
           mov   esi,[edi].DISPACTH_ENTRY.tActionTable
           shl   ebx,2
           push  [lParam]
           push  [wParam]
           push  [uMsg]
           push  [hWnd]
           push  offset _quit
           jmp   DWORD PTR [esi+ebx]
         .ELSEIF [uMsg]==CLI_NOTIFY
           mov eax,[wParam]
           .IF eax >= 0
              mov eax,[tblDecodeMsg+eax*4]
              mov ebx,offset  szStrBuffer
              invoke wsprintf,ebx,eax,[lParam]
              add    esp,3*4
           .ELSE
             .IF eax==ERR_NOSERVER
                mov ebx,offset szError1
             .ELSEIF eax==ERR_WRONGVER
                mov ebx,offset szError2
             .ENDIF
           .ENDIF
           invoke SendDlgItemMessage,hWnd,IDC_LIST,LB_ADDSTRING,0,ebx
         .ELSEIF [uMsg]==CLI_SERVICE 
           invoke SuspendThread,[pif].hThread
           mov eax,[wParam]
           mov [BHR_eip],eax
           mov eax,[pif].dwProcessId 
           mov [BHR_pid],eax
           invoke SendMessageA,[hBhrama],WM_COPYDATA,hWnd,offset BHR_Service
           invoke ResumeThread,[pif].hThread
           invoke TerminateProcess,[pif].hProcess,02081972h
         .ELSEIF [uMsg]==WM_DESTROY
           invoke PostQuitMessage,NULL
           xor    eax,eax
         .ELSE
           invoke DefWindowProc,[hWnd],[uMsg],[wParam],[lParam]
_quit:   .ENDIF  
        ret 
WndProc ENDP         

; loader main routine
doLoad PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        invoke FindWindow,NULL,offset szBhrama
        .IF EAX==0
          invoke ErrorMessage,ERROR_NO_BHRAMASERVER
          jmp _abort
        .ENDIF
        mov  [hBhrama],eax
        call BuildFakeEnviroment
        invoke SendDlgItemMessage,hWnd,IDC_LIST,LB_ADDSTRING,0,offset  szCreateProc
        invoke CreateProcessA,offset szFilePath, \
         offset szCommandLine, \
         NULL, \
         NULL, \
         TRUE, \                           
         CREATE_SUSPENDED+DETACHED_PROCESS+CREATE_DEFAULT_ERROR_MODE, \
         NULL, \
         offset szCurrentDir, \
         offset sif, \
         offset pif
        .IF eax==0
           invoke  ErrorMessage,ERROR_CREATING_PROCESS
           jmp _abort
        .ENDIF 
        invoke GlobalAlloc,GPTR,1000h
        mov    edi,eax  ; get module Nt headers
        .IF (eax!=0)
           invoke FindModuleBase,[pif].hProcess,offset szFilePath
           .IF (eax!=0)
              mov    ebx,eax
              invoke ReadProcessMemory,[pif].hProcess,ebx,edi,1000h,offset cbBytes
              .IF (eax!=0)
                 mov   eax,[edi].IMAGE_DOS_HEADER.e_lfanew
                 add   eax,edi
                 mov   edx,[eax].IMAGE_NT_HEADERS.OptionalHeader.SizeOfImage
                 mov   eax,[eax].IMAGE_NT_HEADERS.OptionalHeader.AddressOfEntryPoint
                 .IF (eax!=0)
                    cmp    eax,edx
                    jl    _ep
                 .ENDIF
              .ENDIF
           .ENDIF
        .ENDIF
        invoke GlobalFree,edi                  
        invoke ErrorMessage,ERROR_READING_HEADER
        jmp _abort 
_ep:
        add    ebx,eax
        mov    edi,offset EntryPoint     ; save original code
        mov    ecx,GateSize
        invoke ReadProcessMemory,[pif].hProcess,ebx,edi,ecx,offset cbBytes
        invoke SendDlgItemMessage,hWnd,IDC_LIST,LB_ADDSTRING,0,offset  szCheckSign
        cmp    byte ptr [edi+7],68h
        jnz    _sign
        cmp    dword ptr [edi+26],50609C66h       ; check version signature
        jz     _gate
_sign:  invoke TerminateProcess,[pif].hProcess,-1
        invoke ErrorMessage,ERROR_INCORRECT_VERSION
        jmp    _abort 
_gate: 
        invoke CreateFileMapping,cMMFromPageFile, \   
         NULL, \
         PAGE_READWRITE, \ 
         0, \
         InjectSize, \
         offset szGateKeeper
        .IF (eax!=0)
           mov    [hFileMap],eax
           invoke MapViewOfFile,eax,FILE_MAP_ALL_ACCESS,NULL,NULL,NULL
           or     eax,eax
           jnz    _init
        .ENDIF
        invoke  ErrorMessage,ERROR_INITIALING_GATE
        jmp _abort
_init: 
        mov    edi,eax        
        call   InitGate
        push   edi
        mov    esi,offset Injected         ; copy our code in a sharable MMF  
        mov    ecx,InjectSize
        rep    movsb
        call   UnmapViewOfFile
        mov    ecx,GateSize
        invoke WriteProcessMemory,[pif].hProcess,ebx,offset Gate,ecx,offset cbBytes
        invoke FlushInstructionCache,[pif].hProcess,NULL,NULL  ; overwrite EP with our stub
        lea  eax,offset SentryThreadProc
        invoke CreateThread,NULL,NULL,eax,[pif].hProcess,0,ADDR ThreadID
        invoke SetThreadPriority,eax,THREAD_PRIORITY_IDLE   ; setup a sentry thread 
        invoke EnableWindow,[hLoadBtn],FALSE
_abort:
        invoke ResumeThread,[pif].hThread 
       ret 
doLoad ENDP

; lame about msgbox
doAbout PROC USES ebx edi esi, hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
      invoke  MessageBox,[hWnd],ADDR szAboutMsg,ADDR szProgramName,0
      ret
doAbout ENDP

; display a open file dialog and file edit with save selected file
doBrowse PROC USES ebx edi esi,hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
        mov     [OFN].lStructSize,sizeof OPENFILENAME
        mov     eax,[hWnd]
        mov     [OFN].hWndOwner,eax
        mov     eax,[hInstance]
        mov     [OFN].hInstance,eax
        mov     [OFN].lpstrFilter,offset szOfnFilter
        mov     [OFN].lpstrFile,offset szFilePath
        mov     [OFN].nMaxFile,MAX_PATH-1
        mov     [OFN].Flags,OFN_PATHMUSTEXIST+OFN_FILEMUSTEXIST+OFN_HIDEREADONLY
        invoke  GetOpenFileName,ADDR OFN
        .IF EAX!=0
           invoke SetDlgItemText,hWnd,IDC_PATH,ADDR szFilePath
           invoke EnableWindow,[hLoadBtn],TRUE
        .ENDIF  
       ret 
doBrowse ENDP

; wait until target hProcess is signaled and check exitcode
SentryThreadProc PROC lpthParam: DWORD
        
        LOCAL  lpExitCode
        
        invoke WaitForSingleObject,[pif].hProcess,INFINITE
        invoke GetExitCodeProcess,[pif].hProcess,ADDR lpExitCode
        .IF dword ptr [lpExitCode]!=02081972h
          mov  eax,offset szFailed
        .ELSE
          mov  eax,offset szSuccess
        .ENDIF  
        invoke MessageBoxA,NULL,eax,offset szProgramName,MB_OK + MB_ICONWARNING
        invoke EnableWindow,[hLoadBtn],TRUE
        invoke CloseHandle,[hFileMap]
        invoke ExitThread,0
       ret        
SentryThreadProc ENDP

; build a valid command line & current dir
BuildFakeEnviroment:
        mov     esi,offset szCommandLine
        mov     byte ptr [esi],22h
        mov     edi,offset szCurrentDir 
        inc     esi
        invoke  _strcpy,offset szFilePath,esi
        invoke  _strcpy,offset szFilePath,edi
        invoke  _strlen,edi
        add     esi,ecx
        mov     word ptr [esi],0022h
        lea     esi,[ecx+edi-1]
        .REPEAT
          .BREAK .IF byte ptr [esi]=='\'
          dec  esi
        .UNTIL (esi<edi)
        mov     byte ptr [esi+1],0
      ret        

ExtractModuleName PROC USES ebx edi esi lpszPath:DWORD, lpBuffer:DWORD
        mov     esi,[lpszPath]
        invoke  _strlen,esi
        add     esi, ecx
        .REPEAT
          .BREAK .IF byte ptr [esi]=='\'
          dec  esi
        .UNTIL (esi<edi)
        inc     esi
        invoke  _strcpy,esi,lpBuffer
        ret
ExtractModuleName ENDP

; walk target's module address space searching a valid PE header
FindModuleBase PROC USES ebx edi hProcess: HANDLE, lpszModuleName: DWORD
        LOCAL mbi      : MEMORY_BASIC_INFORMATION 

        xor edi,edi
        mov ebx,10000h
        .WHILE (ebx < 7FFFFFFFh)
          invoke VirtualQueryEx,[hProcess],ebx,ADDR mbi,sizeof MEMORY_BASIC_INFORMATION 
          mov eax,[mbi].AllocationBase
          .IF ([mbi].State==MEM_FREE && [mbi].State==MEM_RESERVE)
             mov [mbi].BaseAddress,eax
          .ENDIF
          mov ebx,[mbi].BaseAddress
          .IF (ebx==eax && ebx!=0 && word ptr [ebx]==IMAGE_DOS_SIGNATURE)
             mov edi,[ebx].IMAGE_DOS_HEADER.e_lfanew
             add edi,ebx
             invoke IsBadReadPtr,edi,4
             .IF dword ptr [edi]==IMAGE_NT_SIGNATURE
                mov edi,ebx
                .BREAK
             .ENDIF   
          .ENDIF  
          mov eax,[mbi].RegionSize
          add ebx,eax
        .ENDW
        mov eax,edi
      ret  
FindModuleBase ENDP

; setup addresses of API we need (lame method)
InitGate:
        push   ebx
        invoke GetModuleHandle,offset szKernel32
        mov ebx,eax
        invoke GetProcAddress,ebx,offset szOpenFileMappingA
        mov    [_OpenFileMappingA],eax
        invoke GetProcAddress,ebx,offset szMapViewOfFile
        mov    [_MapViewOfFile],eax 
        invoke GetProcAddress,ebx,offset szExitProcess
        mov    [_ExitProcess],eax 
        invoke GetProcAddress,ebx,offset szGetCurrentProcess
        mov    [_GetCurrentProcess],eax 
        invoke GetProcAddress,ebx,offset szSetUnhandledExceptionFilter
        mov    [_SetUnhandledExceptionFilter],eax
        invoke GetProcAddress,ebx,offset szFlushInstructionCache
        mov    [_FlushInstructionCache],eax
        invoke GetProcAddress,ebx,offset szSuspendThread
        mov    [_SuspendThread],eax
        invoke GetModuleHandle,offset szUser32
        mov ebx,eax
        invoke GetProcAddress,ebx,offset szFindWindowA
        mov    [_FindWindowA],eax
        invoke GetProcAddress,ebx,offset szSendMessageA
        mov    [_SendMessageA],eax
        pop    ebx
       ret

ErrorMessage PROC ErrorID:DWORD
        invoke  LoadString,[hInstance],[ErrorID],offset szStrBuffer,szStrBufferl
        .IF eax==0
          lea     eax,szGenErrMsg
        .ELSE
          lea     eax,szStrBuffer  
        .ENDIF
        invoke MessageBox,0,eax,ADDR szProgramName,MB_OK+MB_ICONHAND
       ret
ErrorMessage ENDP

; stolen from ASJ#3 - (c) Xbios2
_strlen PROC src: DWORD 
        mov     ecx,[src]
        mov     edx,ecx
_slen:  inc     ecx
        test    ecx,3
        jz      _dwln
        cmp     byte ptr [ecx],0
        jne     _slen
        jmp     _len
_dwln:  mov     ebx,[ecx]       
        add     ecx,4           
        test    bl,bl           
        jz      _db              
        test    bh,bh           
        jz      _dw              
        test    ebx,0ff0000h    
        jz      _dd              
        test    ebx,0ff000000h  
        jnz     _dwln 
        inc     ecx
_dd:    inc     ecx
_dw:    inc     ecx
_db:    sub     ecx,4
_len:   sub     ecx,edx
      ret 
_strlen ENDP

_strcpy PROC src: DWORD , dest: DWORD
        mov     ecx,[src]
        mov     edx,[dest]      
        push    edx             
        test    edx,3           
        jz      _cpy
_algn:  mov     al,[ecx]
        inc     ecx
        mov     [edx],al
        inc     edx
        test    al,al
        jz      _ret
        test    edx,3
        jnz     _algn
_cpy:   mov     eax,[ecx]
        add     ecx,4
        or      al,al
        jz      _one
        or      ah,ah
        jz      _two
        test    eax,0ff0000h
        jz      _three
        mov     dword ptr [edx],eax
        add     edx,4
        shr     eax,24
        jnz     _cpy
        pop     eax
       ret
_three:mov      byte ptr [edx+2], 0
_two:   mov     word ptr [edx], ax
_ret:   pop     eax             
       ret
_one:   mov     byte ptr [edx], al
        pop     eax             
       ret
_strcpy ENDP 

end start


